Note: This is a public test instance of Red Hat Bugzilla. The data contained within is a snapshot of the live data so any changes you make will not be reflected in the production Bugzilla. Email is disabled so feel free to test any aspect of the site that you want. File any problems you find or give feedback at bugzilla.redhat.com.

Bug 2133439

Summary: Review Request: python-plotnine - Implementation of a grammar of graphics in Python, based on ggplot2
Product: [Fedora] Fedora Reporter: Sandro <gui1ty>
Component: Package ReviewAssignee: Sandro Mani <manisandro>
Status: CLOSED RAWHIDE QA Contact: Fedora Extras Quality Assurance <extras-qa>
Severity: unspecified Docs Contact:
Priority: unspecified    
Version: rawhideCC: manisandro, package-review
Target Milestone: ---Flags: manisandro: fedora-review+
Target Release: ---   
Hardware: Unspecified   
OS: Unspecified   
Whiteboard:
Fixed In Version: Doc Type: If docs needed, set a value
Doc Text:
Story Points: ---
Clone Of: Environment:
Last Closed: 2022-10-25 09:50:34 UTC Type: Bug
Regression: --- Mount Type: ---
Documentation: --- CRM:
Verified Versions: Category: ---
oVirt Team: --- RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: --- Target Upstream Version:
Embargoed:
Bug Depends On: 2130026, 2130030, 2133438    
Bug Blocks: 1276941    

Comment 2 Sandro Mani 2022-10-20 12:57:45 UTC
I'll take this. Can you take one of

https://bugzilla.redhat.com/bugzilla/show_bug.cgi?id=2136237 - mingw-python-installer
https://bugzilla.redhat.com/bugzilla/show_bug.cgi?id=2136238 - mingw-python-pep517

in exchange?

Comment 3 Sandro 2022-10-20 14:19:43 UTC
This one depends on python-scikit-misc, which hasn't been picked up yet (BZ#2133438). The build is in Copr (see links above), which you will need to get this build. Probably for the better do have scikit-misc reviewed first.

As mentioned in mizani review, I'm committing to both of your review requests.

Comment 4 Sandro Mani 2022-10-21 19:53:56 UTC
Full review below, just two issues:

[!]: License file installed when any subpackage combination is installed.
=> Require base package in -doc, or add %license to -doc.

[!]: If the package is under multiple licenses, the licensing breakdown
     must be documented in the spec.
=> Add license breakdown

Approved, but please address these issues before importing.


Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed


===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
[!]: License file installed when any subpackage combination is installed.
[!]: If the package is under multiple licenses, the licensing breakdown
     must be documented in the spec.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package must not depend on deprecated() packages.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

Python:
[ ]: Python eggs must not download any dependencies during the build
     process.
[ ]: A package which is used by another package via an egg interface should
     provide egg info.
[ ]: Package meets the Packaging Guidelines::Python
[x]: Package contains BR: python2-devel or python3-devel
[x]: Packages MUST NOT have dependencies (either build-time or runtime) on
     packages named with the unversioned python- prefix unless no properly
     versioned package exists. Dependencies on Python packages instead MUST
     use names beginning with python2- or python3- as appropriate.
[x]: Python packages must not contain %{pythonX_site(lib|arch)}/* in %files
[x]: Binary eggs must be removed in %prep

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[-]: Fully versioned dependency in subpackages if applicable.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in
     python3-plotnine , python3-plotnine+extra
[?]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Sources are verified with gpgverify first in %prep if upstream
     publishes signatures.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Spec use %global instead of %define unless justified.
     Note: %define requiring justification: %define autorelease(e:s:pb:n)
     %{?-p:0.}%{lua:
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: python3-plotnine-0.10.1-2.fc38.noarch.rpm
          python3-plotnine+extra-0.10.1-2.fc38.noarch.rpm
          python-plotnine-0.10.1-2.fc38.src.rpm
=========================================================================================================== rpmlint session starts ==========================================================================================================
rpmlint: 2.4.0
configuration:
    /usr/lib/python3.11/site-packages/rpmlint/configdefaults.toml
    /etc/xdg/rpmlint/fedora-legacy-licenses.toml
    /etc/xdg/rpmlint/fedora-spdx-licenses.toml
    /etc/xdg/rpmlint/fedora.toml
    /etc/xdg/rpmlint/scoring.toml
    /etc/xdg/rpmlint/users-groups.toml
    /etc/xdg/rpmlint/warn-on-functions.toml
rpmlintrc: [PosixPath('/tmp/tmphi3q9z1f')]
checks: 31, packages: 3

python3-plotnine+extra.noarch: W: no-documentation
============================================================================ 3 packages and 0 specfiles checked; 0 errors, 1 warnings, 0 badness; has taken 2.2 s ===========================================================================




Rpmlint (installed packages)
----------------------------
============================ rpmlint session starts ============================
rpmlint: 2.4.0
configuration:
    /usr/lib/python3.11/site-packages/rpmlint/configdefaults.toml
    /etc/xdg/rpmlint/fedora-legacy-licenses.toml
    /etc/xdg/rpmlint/fedora-spdx-licenses.toml
    /etc/xdg/rpmlint/fedora.toml
    /etc/xdg/rpmlint/scoring.toml
    /etc/xdg/rpmlint/users-groups.toml
    /etc/xdg/rpmlint/warn-on-functions.toml
checks: 31, packages: 2

python3-plotnine+extra.noarch: W: no-documentation
 2 packages and 0 specfiles checked; 0 errors, 1 warnings, 0 badness; has taken 0.4 s 



Source checksums
----------------
https://files.pythonhosted.org/packages/source/p/plotnine/plotnine-0.10.1.tar.gz :
  CHECKSUM(SHA256) this package     : d912a04b638dcf822c51a6788b85664232348d515f151db3a64c0001966f6841
  CHECKSUM(SHA256) upstream package : d912a04b638dcf822c51a6788b85664232348d515f151db3a64c0001966f6841


Requires
--------
python3-plotnine (rpmlib, GLIBC filtered):
    python(abi)
    python3.11dist(matplotlib)
    python3.11dist(mizani)
    python3.11dist(numpy)
    python3.11dist(pandas)
    python3.11dist(patsy)
    python3.11dist(scipy)
    python3.11dist(statsmodels)

python3-plotnine+extra (rpmlib, GLIBC filtered):
    python(abi)
    python3-plotnine
    python3.11dist(adjusttext)
    python3.11dist(geopandas)
    python3.11dist(scikit-learn)
    python3.11dist(scikit-misc)



Provides
--------
python3-plotnine:
    python-plotnine
    python3-plotnine
    python3.11-plotnine
    python3.11dist(plotnine)
    python3dist(plotnine)

python3-plotnine+extra:
    python-plotnine+extra
    python3-plotnine+extra
    python3.11-plotnine+extra
    python3.11dist(plotnine[extra])
    python3dist(plotnine[extra])



Generated by fedora-review 0.9.0 (6761b6c) last change: 2022-08-23
Command line :/usr/bin/fedora-review -b 2133439 -L /home/sandro/Desktop/deps
Buildroot used: fedora-rawhide-x86_64
Active plugins: Python, Generic, Shell-api
Disabled plugins: Java, Perl, fonts, R, Ocaml, SugarActivity, Haskell, PHP, C/C++
Disabled flags: EPEL6, EPEL7, DISTTAG, BATCH, EXARCH

Built with local dependencies:
    /home/sandro/Desktop/deps/python3-mizani-0.8.1-1.fc38.noarch.rpm
    /home/sandro/Desktop/deps/python3-scikit-misc-0.1.4-1.20221021gitv0.1.4.fc38.x86_64.rpm

Comment 5 Gwyn Ciesla 2022-10-24 21:46:02 UTC
(fedscm-admin):  The Pagure repository was created at https://src.fedoraproject.org/rpms/python-plotnine